Index: cprs/trunk/CPRS-Chart/Orders/fODMeds.pas
===================================================================
--- cprs/trunk/CPRS-Chart/Orders/fODMeds.pas	(revision 456)
+++ cprs/trunk/CPRS-Chart/Orders/fODMeds.pas	(revision 829)
@@ -4283,4 +4855,20 @@
   case Key of
 //  VK_RETURN:   //moved to form key press
+  VK_RIGHT:
+    begin
+      if (not FInptDlg) and (self.grdDoses.Col = COL_DURATION) then
+        begin
+          self.grdDoses.Col := COL_SEQUENCE;
+          Key := 0;
+        end;
+    end;
+  VK_LEFT:
+    begin
+      if (not FInptDlg) and (self.grdDoses.Col = COL_SEQUENCE) then
+        begin
+          self.grdDoses.Col := COL_DURATION;
+          Key := 0;
+        end;
+    end;
   VK_ESCAPE:
     begin
@@ -4377,10 +4965,11 @@
 procedure TfrmODMeds.FormKeyPress(Sender: TObject; var Key: Char);
 begin
-  if (Key = #13) and (ActiveControl = grdDoses{pnlXSequence}) then
+ (* if (Key = #13) and (ActiveControl = grdDoses{pnlXSequence}) then
   begin
     ShowEditor(grdDoses.Col, grdDoses.Row, #0);
     Key := #0;  //Don't let the base class turn it into a forward tab!
-  end
-  else if (Key = #13) and (ActiveControl = txtMed) then
+  end *)
+  //else
+  if (Key = #13) and (ActiveControl = txtMed) then
     Key := #0;   //Don't let the base class turn it into a forward tab!
 end;
@@ -4406,5 +4995,5 @@
 end;
 
-procedure TfrmODMeds.pnlXSequenceEnter(Sender: TObject);
+procedure TfrmODMeds.pnlMessageEnter(Sender: TObject);
 begin
   inherited;
@@ -4413,11 +5002,4 @@
 end;
 
-procedure TfrmODMeds.pnlMessageEnter(Sender: TObject);
-begin
-  inherited;
-  DisableDefaultButton(self);
-  DisableCancelButton(self);
-end;
-
 procedure TfrmODMeds.pnlMessageExit(Sender: TObject);
 begin
@@ -4441,5 +5023,5 @@
 begin
   inherited;
-  ShowMessage('The patient instruction field may not be edited.');
+  ShowMsg('The patient instruction field may not be edited.');
   chkPtInstruct.SetFocus;
 end;
@@ -4448,4 +5030,5 @@
 var
   aftHeight: integer;
+  tempAdmin: string;
 begin
   inherited;
@@ -4456,25 +5039,6 @@
   if pnlMessage.Visible then
     pnlMessage.Top := pnlFields.Top + pnlTop.Height + 8;
-end;
-
-procedure TfrmODMeds.spnQuantityChangingEx(Sender: TObject;
-  var AllowChange: Boolean; NewValue: Smallint;
-  Direction: TUpDownDirection);
-var
-  tempQuant: double;
-begin
-  inherited;
-  if Direction = updUp then
-  begin
-    tempQuant := StrToFloatDef(txtQuantity.Text,0) + 1;
-    txtQuantity.Text := FloatToStr(tempQuant);
-  end else if Direction = updDown then
-  begin
-    tempQuant := StrToFloatDef(txtQuantity.Text,0) - 1 ;
-    if tempQuant < 0 then tempQuant := 0;
-    txtQuantity.Text := FloatToStr(tempQuant);
-  end;
-  spnQuantity.Tag := 1;
-  txtQuantity.Tag := 1;
+  tempAdmin := lblAdminSchGetText;
+  if tempAdmin <> '' then lblAdminSchSetText('Admin Time: ' + tempAdmin);
 end;
 
@@ -4483,5 +5047,5 @@
 begin
   inherited;
-  ShowMessage('The patient instruction field may not be edited.');
+  ShowMsg('The patient instruction field may not be edited.');
   chkPtInstruct.SetFocus;
 end;
@@ -4553,6 +5117,12 @@
     cboSchedule.ItemIndex := -1;
     cboSchedule.Text      := '';
-  end;
-  Result := aSchedule;
+  end
+  else
+    begin
+        Result := Piece(aSchedule,U,1);
+        NSSAdminTime := Piece(aschedule,u,2);
+        NSSScheduleType := Piece(aSchedule, U, 3);
+        if FAdminTimeText <> '' then NSSAdminTime := FAdminTimeText;
+    end;
 end;
 
@@ -4579,8 +5149,20 @@
                        (Assigned(lstQuick.Items[lstQuick.ItemIndex].Data)) and
                        (Integer(lstQuick.Selected.Data) > 0)) ;
+  if (btnSelect.Enabled) and (FOrderAction = ORDER_EDIT) then btnSelect.Enabled := false;  
   if (btnSelect.Enabled) and (FRemoveText) then
     txtMed.Text := '';
 end;
 
+
+procedure TfrmODMeds.DisplayDoseNow(Status: boolean);
+begin
+  if not FinptDlg then Status := False;
+  if Status = false then
+    begin
+      if (self.chkDoseNow.Visible = true) and (self.chkDoseNow.Checked = true) then self.chkDoseNow.Checked := false;
+      self.chkDoseNow.Visible := false;
+    end;
+  if status = true then self.chkDoseNow.Visible := true;  
+end;
 
 procedure TfrmODMeds.DispOrderMessage(const AMessage: string);
@@ -4613,4 +5195,6 @@
 procedure TfrmODMeds.FormClose(Sender: TObject; var Action: TCloseAction);
 begin
+  if FCloseCalled then Exit; //Temporary Hack: Close is called 2x for some reason & errors out
+  FCloseCalled := true;
   FResizedAlready := False;
   inherited;
@@ -4626,6 +5210,12 @@
     cboXSchedule.ItemIndex := -1;
     cboXSchedule.Text      := '';
-  end;
-  Result := aSchedule;
+  end
+  else
+    begin
+        Result := Piece(aSchedule,U,1);
+        NSSAdminTime := Piece(aschedule,u,2);
+        NSSScheduleType := Piece(ASchedule, U, 3);
+        if FAdminTimeText <> '' then NSSAdminTime := FAdminTimeText;
+    end;
 end;
 
@@ -4660,7 +5250,11 @@
 procedure TfrmODMeds.FormShow(Sender: TObject);
 begin
+  FCloseCalled := false;
   inherited;
   if ( (cboSchedule.Text = 'OTHER') and FNSSOther and FInptDlg )then
     PostMessage(Handle, UM_NSSOTHER, 0, 0);
+
+  //I was using btnSelect.Top for the following, but it gets moved around
+  Constraints.MinHeight := Constraints.MinHeight + ((Self.Height - cmdQuit.Top) * 2);
 end;
 
@@ -4697,8 +5291,8 @@
       ScheduleCombo.ItemIndex := tmpIndex;
   end;
-  if (Length(ScheduleCombo.Text) > 0) and (ScheduleCombo.ItemIndex < 0) and FInptDlg then
-  begin
-    FShowPnlXScheduleOk := False; //Added for CQ: 7370
-    Application.MessageBox('Please select a valid schedule from the list.'+#13+#13+
+    if (Length(ScheduleCombo.Text) > 0) and (ScheduleCombo.ItemIndex < 0) and FInptDlg then
+        begin
+          FShowPnlXScheduleOk := False; //Added for CQ: 7370
+          Application.MessageBox('Please select a valid schedule from the list.'+#13+#13+
                            'If you would like to create a Day-of-Week schedule please'+
                            ' select ''OTHER'' from the list.',
@@ -4749,4 +5343,9 @@
 
 // CQ: 7397 - Inpatient med orders with PRN cancel due to invalid schedule.
+function TfrmODMeds.GetCacheChunkIndex(idx: integer): integer;
+begin
+  Result := idx div MED_CACHE_CHUNK_SIZE;
+end;
+
 function TfrmODMeds.GetSchedListIndex(SchedCombo: TORComboBox; pSchedule: String):integer;
 var i: integer;
@@ -4772,4 +5371,66 @@
 end;
 
+procedure TfrmODMeds.cboXSequenceChange(Sender: TObject);
+var
+x: string;
+begin
+  inherited;
+ x := cboXSequence.Text;
+ if (x = 'then') and ((ValFor(COL_DURATION, ARow1) = '') or (ValFor(COL_DURATION, ARow1) = '0')) then
+     begin
+       InfoBox('A duration is required when using "Then" as a conjunction' + CRLF + CRLF+
+           'The patient will be instructed to take these doses consecutively, not concurrently.','Duration Warning',MB_OK);
+       x := '';
+     end;
+  cboXSequence.text := x;
+  cboXSequence.ItemIndex := cboXSequence.Items.IndexOf(x);
+  grdDoses.Cells[COL_SEQUENCE, cboXSequence.Tag] := Uppercase(x);
+  //AGP Start Expire add line
+  UpdateStartExpires(valFor(COL_SCHEDULE,self.grdDoses.Row));
+  ControlChange(Sender);
+end;
+
+procedure TfrmODMeds.cboXSequenceEnter(Sender: TObject);
+begin
+  inherited;
+  DisableDefaultButton(self);
+  DisableCancelButton(self);
+end;
+
+procedure TfrmODMeds.cboXSequenceExit(Sender: TObject);
+begin
+  inherited;
+  grdDoses.Cells[COL_SEQUENCE, cboXSequence.Tag] := Uppercase(cboXSequence.Text);
+  if ActiveControl = grdDoses then
+  begin
+    //This next condition seldom occurs, since entering the dosage on the last
+    // row adds another row
+    if grdDoses.Row = grdDoses.RowCount - 1 then
+      grdDoses.RowCount := grdDoses.RowCount + 1;
+  end;
+  cboXSequence.Tag := -1;
+  cboXSequence.Hide;
+  RestoreDefaultButton;
+  RestoreCancelButton;
+  if (pnlMessage.Visible) and (memMessage.TabStop) then
+  begin
+    pnlMessage.Parent := grdDoses.Parent;
+    pnlMessage.TabOrder := grdDoses.TabOrder;
+    ActiveControl := memMessage;
+  end
+  else if grdDoses.Showing then
+    ActiveControl := grdDoses
+  else
+    ActiveControl := cboDosage;
+  //AGP Start Expire commented out line
+  //UpdateStartExpires(valFor(COL_SCHEDULE,self.grdDoses.Row));
+end;
+
+procedure TfrmODMeds.cboXSequence1Exit(Sender: TObject);
+begin
+  inherited;
+  cboxSequence.Hide;
+end;
+
 procedure TfrmODMeds.cboDosageKeyUp(Sender: TObject; var Key: Word;
   Shift: TShiftState);
@@ -4778,5 +5439,7 @@
   //Fix for CQ: 7545
   if cboDosage.ItemIndex > -1 then
-    cboDosageClick(Sender);
+    cboDosageClick(Sender)
+  else
+    UpdateRelated;
 end;
 
@@ -4787,5 +5450,10 @@
   //Fix for CQ: 7545
   if cboXDosage.ItemIndex > -1 then
-    cboXDosageClick(Sender);
+    cboXDosageClick(Sender)
+  else
+    begin
+      grdDoses.Cells[COL_DOSAGE, cboXDosage.Tag] := cboXDosage.Text;
+      UpdateRelated;
+    end;
 end;
 
@@ -4800,4 +5468,10 @@
   inherited;
    self.txtQuantity.SelectAll;
+end;
+
+procedure TfrmODMeds.txtRefillsChange(Sender: TObject);
+begin
+  inherited;
+  ControlChange(sender);
 end;
 
@@ -4830,7 +5504,8 @@
 begin
   inherited;
-  //agp Change CQ 10719 
+  //agp Change CQ 10719
    self.chkXPRN.OnClick(self.chkXPRN);
 end;
 
+
 end.
